{
  open Parser
}

rule lexer = parse
| [' ' '\t' '\n']   (* espace, tabulation et retour chariot
       	    	       sont des séparateurs *)	
  { lexer lexbuf }
| "("	    
  { LPAR }
| ")"	    
  { RPAR }
| "="       
  { EQUAL }
| "<"	    
  { LT }
| "*" 
  { TIMES }
| "+" 
  { PLUS }
| "-" 
  { MINUS }
| ";" 
  { SEQ }
| "<-"
  { SET }
| "true"  (* on renvoie le lexème BOOL avec l'attribut true *)
  { BOOL true }
| "false" 
  { BOOL false }
| "skip"
  { SKIP }
| ['_''a'-'z' 'A'-'Z'] ['_''a'-'z' 'A'-'Z' '0'-'9']*
  { IDENT (Lexing.lexeme lexbuf) }
| '-'?['0'-'9']+ 
  { INT (int_of_string (Lexing.lexeme lexbuf)) }
| eof			  
  { EOF }

