%{
  (* on a besoin de connaître ce qui est dans le fichier term.ml *)
  open Term
%}

  /* on commence par donner l'ensemble des lexèmes utilisés */

%token LPAR RPAR EQUAL LT 
%token <string> IDENT
%token <int> INT
%token <bool> BOOL
%token PLUS TIMES MINUS 
%token IF THEN ELSE SKIP SET SEQ
%token EOF

/* ici les associativités (left, right, nonassoc) et les priorités,
   par priorité croissante (même ligne = même priorité */

%right SEQ



%start comm   /* l'automate doit chercher à reconnaitre un comm */
%type <Term.command> comm /* à un comm reconnu est associé une valeur
       de type Term.command (le type command défini dans le fichier term.ml) */

/* ci-dessous les règles de grammaire;
   on définit trois ensembles de règles (a_ex, b_ex, comm);
   à chaque fois, on décrit ce qui doit être reconnu, puis ce qui est
     associé (entre accolades) */

%%  /* ces deux % ne sont pas décoratifs -- ils agissent en séparateurs */

a_ex : 
  | INT {
    ACst $1 }
  | IDENT {
    AVar $1 }

comm :
  | SKIP {
    CSkip }
  | IDENT SET a_ex {
    CAff ($1,$3) }
  | comm SEQ comm {
    CSeq ($1,$3) }

%%  
(* fin des règles *)


